--[[
AdiBags - Classic
by Zottelchen
version: 1.0.4
Items from the main game.
]]

local addonName, addon = ...
local AdiBags = LibStub("AceAddon-3.0"):GetAddon("AdiBags")

local L = addon.L
local MatchIDs
local Result = {}

local function AddToSet(...)
  local Set = {}
  for _, l in ipairs({ ... }) do
    for _, v in ipairs(l) do
      Set[v] = true
    end
  end
  return Set
end

local database = {}

-- Bandages
database["Bandages"] = {
  1251, -- Linen Bandage
  2581, -- Heavy Linen Bandage
  3530, -- Wool Bandage
  3531, -- Heavy Wool Bandage
  6450, -- Silk Bandage
  6451, -- Heavy Silk Bandage
  8544, -- Mageweave Bandage
  8545, -- Heavy Mageweave Bandage
  14529, -- Runecloth Bandage
  14530, -- Heavy Runecloth Bandage
  19066, -- Warsong Gulch Runecloth Bandage
  19067, -- Warsong Gulch Mageweave Bandage
  19068, -- Warsong Gulch Silk Bandage
  19307, -- Alterac Heavy Runecloth Bandage
  20065, -- Arathi Basin Mageweave Bandage
  20066, -- Arathi Basin Runecloth Bandage
  20067, -- Arathi Basin Silk Bandage
  20232, -- Defiler's Mageweave Bandage
  20234, -- Defiler's Runecloth Bandage
  20235, -- Defiler's Silk Bandage
  20237, -- Highlander's Mageweave Bandage
  20243, -- Highlander's Runecloth Bandage
  20244, -- Highlander's Silk Bandage
}

-- Consumables
database["Consumables"] = {
  3384, -- ERROR1
  3393, -- ERROR1
  4358, -- Rough Dynamite
  4360, -- Rough Copper Bomb
  4365, -- Coarse Dynamite
  4366, -- Target Dummy
  4367, -- Small Seaforium Charge
  4370, -- Large Copper Bomb
  4374, -- Small Bronze Bomb
  4376, -- Flame Deflector
  4378, -- Heavy Dynamite
  4380, -- Big Bronze Bomb
  4384, -- Explosive Sheep
  4386, -- Ice Deflector
  4388, -- Discombobulator Ray
  4390, -- Iron Grenade
  4391, -- Compact Harvest Reaper Kit
  4392, -- Advanced Target Dummy
  4394, -- Big Iron Bomb
  4395, -- Goblin Land Mine
  4398, -- Large Seaforium Charge
  4403, -- Portable Bronze Mortar
  4852, -- Flash Bomb
  5507, -- Ornate Spyglass
  6265, -- ERROR1
  6714, -- EZ-Thro Dynamite
  7148, -- Goblin Jumper Cables
  7809, -- ERROR1
  9036, -- ERROR1
  9293, -- ERROR1
  9299, -- ERROR1
  10507, -- Solid Dynamite
  10514, -- Mithril Frag Bomb
  10562, -- Hi-Explosive Bomb
  10586, -- The Big One
  10646, -- Goblin Sapper Charge
  10757, -- ERROR1
  10978, -- ERROR1
  10998, -- ERROR1
  11079, -- ERROR1
  11082, -- ERROR1
  11083, -- ERROR1
  11084, -- ERROR1
  11098, -- ERROR1
  11134, -- ERROR1
  11135, -- ERROR1
  11137, -- ERROR1
  11138, -- ERROR1
  11139, -- ERROR1
  11174, -- ERROR1
  11175, -- ERROR1
  11177, -- ERROR1
  11178, -- ERROR1
  11224, -- ERROR1
  11590, -- Mechanical Repair Kit
  13140, -- ERROR1
  15993, -- Thorium Grenade
  16005, -- Dark Iron Bomb
  16023, -- Masterwork Target Dummy
  16040, -- Arcane Bomb
  18232, -- Field Repair Bot 74A
  18587, -- Goblin Jumper Cables XL
  18588, -- EZ-Thro Dynamite II
  18594, -- Powerful Seaforium Charge
  18641, -- Dense Dynamite
  18645, -- Gnomish Alarm-o-Bot
  20725, -- ERROR1
}

-- Foods and Drinks
database["FoodsandDrinks"] = {
  117, -- Tough Jerky
  159, -- Refreshing Spring Water
  414, -- Dalaran Sharp
  422, -- Dwarven Mild
  724, -- Goretusk Liver Pie
  733, -- Westfall Stew
  787, -- Slitherskin Mackerel
  961, -- Healing Herb
  1017, -- Seasoned Wolf Kabob
  1082, -- Redridge Goulash
  1113, -- Conjured Bread
  1114, -- Conjured Rye
  1179, -- Ice Cold Milk
  1205, -- Melon Juice
  1401, -- Riverpaw Tea Leaf
  1487, -- Conjured Pumpernickel
  1645, -- Moonberry Juice
  1707, -- Stormwind Brie
  1708, -- Sweet Nectar
  2070, -- Darnassian Bleu
  2136, -- Conjured Purified Water
  2287, -- Haunch of Meat
  2288, -- Conjured Fresh Water
  2593, -- Flask of Stormwind Tawny
  2594, -- Flagon of Dwarven Mead
  2595, -- Jug of Badlands Bourbon
  2596, -- Skin of Dwarven Stout
  2679, -- Charred Wolf Meat
  2680, -- Spiced Wolf Meat
  2681, -- Roasted Boar Meat
  2682, -- Cooked Crab Claw
  2683, -- Crab Cake
  2684, -- Coyote Steak
  2685, -- Succulent Pork Ribs
  2686, -- Thunder Ale
  2687, -- Dry Pork Ribs
  2723, -- Bottle of Dalaran Noir
  2888, -- Beer Basted Boar Ribs
  2894, -- Rhapsody Malt
  3220, -- Blood Sausage
  3662, -- Crocolisk Steak
  3663, -- Murloc Fin Soup
  3664, -- Crocolisk Gumbo
  3665, -- Curiously Tasty Omelet
  3666, -- Gooey Spider Cake
  3703, -- Southshore Stout
  3726, -- Big Bear Steak
  3727, -- Hot Lion Chops
  3728, -- Tasty Lion Steak
  3729, -- Soothing Turtle Bisque
  3770, -- Mutton Chop
  3771, -- Wild Hog Shank
  3772, -- Conjured Spring Water
  3927, -- Fine Aged Cheddar
  4457, -- Barbecued Buzzard Wing
  4536, -- Shiny Red Apple
  4537, -- Tel'Abim Banana
  4538, -- Snapvine Watermelon
  4539, -- Goldenbark Apple
  4540, -- Tough Hunk of Bread
  4541, -- Freshly Baked Bread
  4542, -- Moist Cornbread
  4544, -- Mulgore Spice Bread
  4592, -- Longjaw Mud Snapper
  4593, -- Bristle Whisker Catfish
  4594, -- Rockscale Cod
  4595, -- Junglevine Wine
  4599, -- Cured Ham Steak
  4600, -- Cherry Grog
  4601, -- Soft Banana Bread
  4602, -- Moon Harvest Pumpkin
  4604, -- Forest Mushroom Cap
  4605, -- Red-Speckled Mushroom
  4606, -- Spongy Morel
  4607, -- Delicious Cave Mold
  4608, -- Raw Black Truffle
  4656, -- Small Pumpkin
  4791, -- Enchanted Water
  5057, -- Ripe Watermelon
  5066, -- Fissure Plant
  5095, -- Rainbow Fin Albacore
  5205, -- Sprouted Frond
  5342, -- Raptor Punch
  5349, -- Conjured Muffin
  5350, -- Conjured Water
  5472, -- Kaldorei Spider Kabob
  5473, -- Scorpid Surprise
  5474, -- Roasted Kodo Meat
  5476, -- Fillet of Frenzy
  5477, -- Strider Stew
  5478, -- Dig Rat Stew
  5479, -- Crispy Lizard Tail
  5480, -- Lean Venison
  5512, -- Healthstone
  5513, -- Mana Jade
  5525, -- Boiled Clams
  5526, -- Clam Chowder
  5527, -- Goblin Deviled Clams
  6038, -- Giant Clam Scorcho
  6290, -- Brilliant Smallfish
  6299, -- Sickly Looking Fish
  6316, -- Loch Frenzy Delight
  6458, -- Oil Covered Fish
  6522, -- Deviate Fish
  6657, -- Savory Deviate Delight
  6807, -- Frog Leg Stew
  6887, -- Spotted Yellowtail
  6888, -- Herb Baked Egg
  6890, -- Smoked Bear Meat
  7097, -- Leg Meat
  7228, -- Tigule's Strawberry Ice Cream
  7676, -- Thistle Tea
  7806, -- Lollipop
  7807, -- Candy Bar
  7808, -- Chocolate Square
  8007, -- Mana Citrine
  8008, -- Mana Ruby
  8075, -- Conjured Sourdough
  8076, -- Conjured Sweet Roll
  8077, -- Conjured Mineral Water
  8078, -- Conjured Sparkling Water
  8079, -- Conjured Crystal Water
  8364, -- Mithril Head Trout
  8766, -- Morning Glory Dew
  8932, -- Alterac Swiss
  8948, -- Dried King Bolete
  8950, -- Homemade Cherry Pie
  8952, -- Roasted Quail
  8953, -- Deep Fried Plantains
  8957, -- Spinefin Halibut
  9260, -- Volatile Rum
  9451, -- Bubbling Water
  10841, -- Goldthorn Tea
  11109, -- Special Chicken Feed
  11415, -- Mixed Berries
  11444, -- Grim Guzzler Boar
  11584, -- Cactus Apple Surprise
  12209, -- Lean Wolf Steak
  12210, -- Roast Raptor
  12212, -- Jungle Stew
  12213, -- Carrion Surprise
  12214, -- Mystery Stew
  12215, -- Heavy Kodo Stew
  12216, -- Spiced Chili Crab
  12217, -- Dragonbreath Chili
  12218, -- Monster Omelet
  12224, -- Crispy Bat Wing
  12238, -- Darkshore Grouper
  13546, -- Bloodbelly Fish
  13724, -- Enriched Manna Biscuit
  13755, -- Winter Squid
  13810, -- Blessed Sunfruit
  13813, -- Blessed Sunfruit Juice
  13851, -- Hot Wolf Ribs
  13893, -- Large Raw Mightfish
  13927, -- Cooked Glossy Mightfish
  13928, -- Grilled Squid
  13929, -- Hot Smoked Bass
  13930, -- Filet of Redgill
  13931, -- Nightfin Soup
  13932, -- Poached Sunscale Salmon
  13933, -- Lobster Stew
  13934, -- Mightfish Steak
  13935, -- Baked Salmon
  14894, -- Lily Root
  16166, -- Bean Soup
  16167, -- Versicolor Treat
  16168, -- Heaven Peach
  16169, -- Wild Ricecake
  16170, -- Steamed Mandu
  16766, -- Undermine Clam Chowder
  17119, -- Deeprun Rat Kabob
  17196, -- Holiday Spirits
  17197, -- Gingerbread Cookie
  17198, -- Winter Veil Egg Nog
  17222, -- Spider Sausage
  17344, -- Candy Cane
  17402, -- Greatfather's Winter Ale
  17403, -- Steamwheedle Fizzy Spirits
  17404, -- Blended Bean Brew
  17406, -- Holiday Cheesewheel
  17407, -- Graccu's Homemade Meat Pie
  17408, -- Spicy Beefstick
  17747, -- Razorlash Root
  18045, -- Tender Wolf Steak
  18254, -- Runn Tum Tuber Surprise
  18255, -- Runn Tum Tuber
  18287, -- Evermurky
  18288, -- Molasses Firewater
  18300, -- Hyjal Nectar
  18632, -- Moonbrook Riot Taffy
  18633, -- Styleen's Sour Suckerpop
  18635, -- Bellara's Nutterbar
  19060, -- Warsong Gulch Enriched Ration
  19061, -- Warsong Gulch Iron Ration
  19062, -- Warsong Gulch Field Ration
  19221, -- Darkmoon Special Reserve
  19222, -- Cheap Beer
  19223, -- Darkmoon Dog
  19224, -- Red Hot Wings
  19225, -- Deep Fried Candybar
  19299, -- Fizzy Faire Drink
  19300, -- Bottled Winterspring Water
  19301, -- Alterac Manna Biscuit
  19304, -- Spiced Beef Jerky
  19305, -- Pickled Kodo Foot
  19306, -- Crunchy Frog
  19318, -- Bottled Alterac Spring Water
  19696, -- Harvest Bread
  19994, -- Harvest Fruit
  19995, -- Harvest Boar
  19996, -- Harvest Fish
  19997, -- Harvest Nectar
  20062, -- Arathi Basin Enriched Ration
  20063, -- Arathi Basin Field Ration
  20064, -- Arathi Basin Iron Ration
  20074, -- Heavy Crocolisk Stew
  20222, -- Defiler's Enriched Ration
  20223, -- Defiler's Field Ration
  20224, -- Defiler's Iron Ration
  20225, -- Highlander's Enriched Ration
  20226, -- Highlander's Field Ration
  20227, -- Highlander's Iron Ration
  20388, -- Lollipop
  20389, -- Candy Corn
  20390, -- Candy Bar
  20452, -- Smoked Desert Dumplings
  20516, -- Bobbing Apple
  20709, -- Rumsey Rum Light
  21023, -- Dirge's Kickin' Chimaerok Chops
  21030, -- Darnassus Kimchi Pie
  21031, -- Cabbage Kimchi
  21033, -- Radish Kimchi
  21072, -- Smoked Sagefish
  21114, -- Rumsey Rum Dark
  21151, -- Rumsey Rum Black Label
  21215, -- Graccu's Mince Meat Fruitcake
  21217, -- Sagefish Delight
  21235, -- Winter Veil Roast
  21241, -- Winter Veil Eggnog
  21254, -- Winter Veil Cookie
  21537, -- Festival Dumplings
  21552, -- Striped Yellowtail
  21721, -- Moonglow
  22236, -- Buttermilk Delight
  22237, -- Dark Desire
  22238, -- Very Berry Cream
  22239, -- Sweet Surprise
  22324, -- Winter Kimchi
  22895, -- Conjured Cinnamon Roll
  23160, -- Friendship Bread
  23161, -- Freshly-Squeezed Lemonade
}

-- Other Consumables
database["OtherConsumables"] = {
  954, -- Scroll of Strength
  955, -- Scroll of Intellect
  1127, -- Flash Bundle
  1177, -- Oil of Olaf
  1180, -- Scroll of Stamina
  1181, -- Scroll of Versatility
  1187, -- Spiked Collar
  1399, -- Magic Candle
  1477, -- Scroll of Agility II
  1478, -- Scroll of Protection II
  1711, -- Scroll of Stamina II
  1712, -- Scroll of Versatility II
  2091, -- Magic Dust
  2289, -- Scroll of Strength II
  2290, -- Scroll of Intellect II
  3012, -- Scroll of Agility
  3013, -- Scroll of Protection
  3434, -- Slumber Sand
  4419, -- Scroll of Intellect III
  4421, -- Scroll of Protection III
  4422, -- Scroll of Stamina III
  4424, -- Scroll of Versatility III
  4425, -- Scroll of Agility III
  4426, -- Scroll of Strength III
  4479, -- Burning Charm
  4480, -- Thundering Charm
  4481, -- Cresting Charm
  5042, -- Red Ribboned Wrapping Paper
  5043, -- Red Ribboned Gift
  5044, -- Blue Ribboned Gift
  5048, -- Blue Ribboned Wrapping Paper
  5206, -- Bogling Root
  5232, -- Soulstone
  5457, -- Severed Voodoo Claw
  5740, -- Red Fireworks Rocket
  5951, -- Moist Towelette
  6452, -- Anti-Venom
  6453, -- Strong Anti-Venom
  6464, -- Wailing Essence
  6781, -- Bartleby's Mug
  6782, -- Marshal Haggard's Badge
  6812, -- Case of Elunite
  7266, -- Ur's Treatise on Shadow Magic
  7627, -- Dolanaar Delivery
  8048, -- Emerald Dreamcatcher
  8444, -- Executioner's Key
  8548, -- Divino-Matic Rod
  8956, -- Oil of Immolation
  9312, -- Blue Firework
  9313, -- Green Firework
  9314, -- Red Streaks Firework
  9315, -- Yellow Rose Firework
  9317, -- Red, White and Blue Firework
  9318, -- Red Firework
  9546, -- Simple Scroll
  9569, -- Hallowed Scroll
  10305, -- Scroll of Protection IV
  10306, -- Scroll of Versatility IV
  10307, -- Scroll of Stamina IV
  10308, -- Scroll of Intellect IV
  10309, -- Scroll of Agility IV
  10310, -- Scroll of Strength IV
  10621, -- Runed Scroll
  10684, -- Colossal Parachute
  10687, -- Empty Vial Labeled #1
  10688, -- Empty Vial Labeled #2
  10689, -- Empty Vial Labeled #3
  10690, -- Empty Vial Labeled #4
  11325, -- Dark Iron Ale Mug
  11914, -- Empty Cursed Ooze Jar
  11948, -- Empty Tainted Ooze Jar
  11953, -- Empty Pure Sample Jar
  12533, -- Roughshod Pike
  12586, -- Immature Venom Sac
  12712, -- Warosh's Mojo
  12884, -- Arnak's Hoof
  12885, -- Pamela's Doll
  12894, -- Joseph's Wedding Ring
  13155, -- Resonating Skull
  13508, -- Eye of Arachnida
  13509, -- Clutch of Foresight
  13514, -- Wail of the Banshee
  13703, -- Kodo Bone
  14542, -- Kravel's Crate
  15778, -- Mechanical Yeti
  15869, -- Silver Skeleton Key
  15870, -- Golden Skeleton Key
  15871, -- Truesilver Skeleton Key
  15872, -- Arcanite Skeleton Key
  16282, -- Bundle of Hides
  17048, -- Rumsey Rum
  17302, -- Blue Ribboned Holiday Gift
  17303, -- Blue Ribboned Wrapping Paper
  17304, -- Green Ribboned Wrapping Paper
  17305, -- Green Ribboned Holiday Gift
  17307, -- Purple Ribboned Wrapping Paper
  17308, -- Purple Ribboned Holiday Gift
  18169, -- Flame Mantle of the Dawn
  18170, -- Frost Mantle of the Dawn
  18171, -- Arcane Mantle of the Dawn
  18172, -- Nature Mantle of the Dawn
  18173, -- Shadow Mantle of the Dawn
  18182, -- Chromatic Mantle of the Dawn
  18269, -- Gordok Green Grog
  18284, -- Kreeg's Stout Beatdown
  18297, -- Thornling Seed
  18606, -- Alliance Battle Standard
  18607, -- Horde Battle Standard
  18640, -- Happy Fun Rock
  18662, -- Heavy Leather Ball
  19026, -- Snake Burst Firework
  19045, -- Stormpike Battle Standard
  19046, -- Frostwolf Battle Standard
  19150, -- Sentinel Basic Care Package
  19151, -- Sentinel Standard Care Package
  19152, -- Sentinel Advanced Care Package
  19153, -- Outrider Advanced Care Package
  19154, -- Outrider Basic Care Package
  19155, -- Outrider Standard Care Package
  19183, -- Hourglass Sand
  19425, -- Mysterious Lockbox
  19440, -- Powerful Anti-Venom
  20228, -- Defiler's Advanced Care Package
  20229, -- Defiler's Basic Care Package
  20230, -- Defiler's Standard Care Package
  20231, -- Arathor Advanced Care Package
  20233, -- Arathor Basic Care Package
  20236, -- Arathor Standard Care Package
  20391, -- Gnome Male Mask
  20392, -- Gnome Female Mask
  20397, -- Hallowed Wand - Pirate
  20398, -- Hallowed Wand - Ninja
  20399, -- Hallowed Wand - Leper Gnome
  20409, -- Hallowed Wand - Ghost
  20410, -- Hallowed Wand - Bat
  20411, -- Hallowed Wand - Skeleton
  20413, -- Hallowed Wand - Random
  20414, -- Hallowed Wand - Wisp
  20470, -- Solanian's Scrying Orb
  20471, -- Scroll of Scourge Magic
  20472, -- Solanian's Journal
  20557, -- Hallow's End Pumpkin Treat
  20561, -- Dwarf Male Mask
  20562, -- Dwarf Female Mask
  20563, -- Night Elf Female Mask
  20564, -- Night Elf Male Mask
  20565, -- Human Female Mask
  20566, -- Human Male Mask
  20567, -- Troll Female Mask
  20568, -- Troll Male Mask
  20569, -- Orc Female Mask
  20570, -- Orc Male Mask
  20571, -- Tauren Female Mask
  20572, -- Tauren Male Mask
  20573, -- Undead Male Mask
  20574, -- Undead Female Mask
  21212, -- Fresh Holly
  21325, -- Mechanical Greench
  21711, -- Lunar Festival Invitation
  21740, -- Small Rocket Recipes
  21741, -- Cluster Rocket Recipes
  21742, -- Large Rocket Recipes
  21743, -- Large Cluster Rocket Recipes
  21744, -- Lucky Rocket Cluster
  21745, -- Elder's Moonstone
  21746, -- Lucky Red Envelope
  23211, -- Toasted Smorc
  23246, -- Fiery Festival Brew
  23326, -- Midsummer Sausage
  23327, -- Fire-Toasted Bun
  23435, -- Elderberry Pie
}

-- Elixirs
database["Elixirs"] = {
  2454, -- Elixir of Lion's Strength
  2457, -- Elixir of Minor Agility
  2458, -- Elixir of Minor Fortitude
  3382, -- Weak Troll's Blood Elixir
  3383, -- Elixir of Wisdom
  3388, -- Strong Troll's Blood Elixir
  3389, -- Elixir of Defense
  3390, -- Elixir of Lesser Agility
  3391, -- Elixir of Ogre's Strength
  3825, -- Elixir of Fortitude
  3826, -- Major Troll's Blood Elixir
  3828, -- Elixir of Detect Lesser Invisibility
  5996, -- Elixir of Water Breathing
  5997, -- Elixir of Minor Defense
  6373, -- Elixir of Firepower
  6662, -- Elixir of Giant Growth
  8529, -- Noggenfogger Elixir
  8827, -- Elixir of Water Walking
  8949, -- Elixir of Agility
  8951, -- Elixir of Greater Defense
  9088, -- Gift of Arthas
  9154, -- Elixir of Detect Undead
  9155, -- Arcane Elixir
  9179, -- Elixir of Greater Intellect
  9187, -- Elixir of Greater Agility
  9197, -- Elixir of Dream Vision
  9206, -- Elixir of Giants
  9224, -- Elixir of Demonslaying
  9233, -- Elixir of Detect Demon
  9264, -- Elixir of Shadow Power
  10592, -- Catseye Elixir
  12820, -- Winterfall Firewater
  13445, -- Elixir of Superior Defense
  13447, -- Elixir of the Sages
  13452, -- Elixir of the Mongoose
  13453, -- Elixir of Brute Force
  13454, -- Greater Arcane Elixir
  17708, -- Elixir of Frost Power
  18294, -- Elixir of Greater Water Breathing
  20004, -- Mighty Troll's Blood Elixir
  20007, -- Mageblood Elixir
  21546, -- Elixir of Greater Firepower
}

-- Flasks
database["Flasks"] = {
  13510, -- Flask of the Titans
  13511, -- Flask of Distilled Wisdom
  13512, -- Flask of Supreme Power
}

-- Potions
database["Potions"] = {
  118, -- Minor Healing Potion
  858, -- Lesser Healing Potion
  929, -- Healing Potion
  1710, -- Greater Healing Potion
  2455, -- Minor Mana Potion
  2456, -- Minor Rejuvenation Potion
  2459, -- Swiftness Potion
  3385, -- Lesser Mana Potion
  3386, -- Potion of Curing
  3387, -- Limited Invulnerability Potion
  3823, -- Lesser Invisibility Potion
  3827, -- Mana Potion
  3928, -- Superior Healing Potion
  4596, -- Discolored Healing Potion
  4623, -- Lesser Stoneshield Potion
  5631, -- Rage Potion
  5633, -- Great Rage Potion
  5634, -- Free Action Potion
  6048, -- Shadow Protection Potion
  6049, -- Fire Protection Potion
  6050, -- Frost Protection Potion
  6051, -- Holy Protection Potion
  6052, -- Nature Protection Potion
  6149, -- Greater Mana Potion
  6372, -- Swim Speed Potion
  9030, -- Restorative Potion
  9144, -- Wildvine Potion
  9172, -- Invisibility Potion
  12190, -- Dreamless Sleep Potion
  13442, -- Mighty Rage Potion
  13443, -- Superior Mana Potion
  13444, -- Major Mana Potion
  13446, -- Major Healing Potion
  13455, -- Greater Stoneshield Potion
  13456, -- Greater Frost Protection Potion
  13457, -- Greater Fire Protection Potion
  13458, -- Greater Nature Protection Potion
  13459, -- Greater Shadow Protection Potion
  13460, -- Greater Holy Protection Potion
  13461, -- Greater Arcane Protection Potion
  13462, -- Purification Potion
  13506, -- Potion of Petrification
  17348, -- Major Healing Draught
  17349, -- Superior Healing Draught
  17351, -- Major Mana Draught
  17352, -- Superior Mana Draught
  18253, -- Major Rejuvenation Potion
  18839, -- Combat Healing Potion
  18841, -- Combat Mana Potion
  20002, -- Greater Dreamless Sleep Potion
  20008, -- Living Action Potion
}

-- Healthstone
database["Healthstone"] = {
  5512, -- Healthstone
}

-- Permanent Enhancements
database["PermanentEnhancements"] = {
  2304, -- Light Armor Kit
  2313, -- Medium Armor Kit
  4265, -- Heavy Armor Kit
  4405, -- Crude Scope
  4406, -- Standard Scope
  4407, -- Accurate Scope
  6041, -- Steel Weapon Chain
  6042, -- Iron Shield Spike
  6043, -- Iron Counterweight
  7967, -- Mithril Shield Spike
  7969, -- Mithril Spurs
  8173, -- Thick Armor Kit
  10546, -- Deadly Scope
  10548, -- Sniper Scope
  12645, -- Thorium Shield Spike
  15564, -- Rugged Armor Kit
  18251, -- Core Armor Kit
  18283, -- Biznicks 247x128 Accurascope
  19971, -- High Test Eternium Fishing Line
}

-- Temporary Enhancements
database["TemporaryEnhancements"] = {
  2862, -- Rough Sharpening Stone
  2863, -- Coarse Sharpening Stone
  2871, -- Heavy Sharpening Stone
  3239, -- Rough Weightstone
  3240, -- Coarse Weightstone
  3241, -- Heavy Weightstone
  3824, -- Shadow Oil
  3829, -- Frost Oil
  6529, -- Shiny Bauble
  6530, -- Nightcrawlers
  6532, -- Bright Baubles
  6533, -- Aquadynamic Fish Attractor
  6811, -- Aquadynamic Fish Lens
  7307, -- Flesh Eating Worm
  7964, -- Solid Sharpening Stone
  7965, -- Solid Weightstone
  12404, -- Dense Sharpening Stone
  12643, -- Dense Weightstone
  18262, -- Elemental Sharpening Stone
  20744, -- Minor Wizard Oil
  20745, -- Minor Mana Oil
  20746, -- Lesser Wizard Oil
  20747, -- Lesser Mana Oil
  20750, -- Wizard Oil
}

-- Cloth
database["Cloth"] = {
  2320, -- Coarse Thread
  2321, -- Fine Thread
  2589, -- Linen Cloth
  2592, -- Wool Cloth
  2996, -- Bolt of Linen Cloth
  2997, -- Bolt of Woolen Cloth
  3182, -- Spider's Silk
  4291, -- Silken Thread
  4305, -- Bolt of Silk Cloth
  4306, -- Silk Cloth
  4337, -- Thick Spider's Silk
  4338, -- Mageweave Cloth
  4339, -- Bolt of Mageweave
  8343, -- Heavy Silken Thread
  10285, -- Shadow Silk
  14047, -- Runecloth
  14048, -- Bolt of Runecloth
  14227, -- Ironweb Spider Silk
  14256, -- Felcloth
  14341, -- Rune Thread
  14342, -- Mooncloth
}

-- Elemental
database["Elemental"] = {
  7067, -- Elemental Earth
  7068, -- Elemental Fire
  7069, -- Elemental Air
  7070, -- Elemental Water
  7075, -- Core of Earth
  7076, -- Essence of Earth
  7077, -- Heart of Fire
  7078, -- Essence of Fire
  7079, -- Globe of Water
  7080, -- Essence of Water
  7081, -- Breath of Wind
  7082, -- Essence of Air
  7972, -- Ichor of Undeath
  10286, -- Heart of the Wild
  12803, -- Living Essence
  12808, -- Essence of Undeath
}

-- Enchanting
database["Enchanting"] = {
  6217, -- Copper Rod
  10938, -- Lesser Magic Essence
  10939, -- Greater Magic Essence
  10940, -- Strange Dust
  14343, -- Small Brilliant Shard
  14344, -- Large Brilliant Shard
  16202, -- Lesser Eternal Essence
  16203, -- Greater Eternal Essence
  16204, -- Light Illusion Dust
}

-- Herbs
database["Herbs"] = {
  765, -- Silverleaf
  785, -- Mageroyal
  2447, -- Peacebloom
  2449, -- Earthroot
  2450, -- Briarthorn
  2452, -- Swiftthistle
  2453, -- Bruiseweed
  3355, -- Wild Steelbloom
  3356, -- Kingsblood
  3357, -- Liferoot
  3358, -- Khadgar's Whisker
  3369, -- Grave Moss
  3818, -- Fadeleaf
  3819, -- Dragon's Teeth
  3820, -- Stranglekelp
  3821, -- Goldthorn
  4625, -- Firebloom
  8153, -- Wildvine
  8831, -- Purple Lotus
  8836, -- Arthas' Tears
  8838, -- Sungrass
  8839, -- Blindweed
  8845, -- Ghost Mushroom
  8846, -- Gromsblood
  13463, -- Dreamfoil
  13464, -- Golden Sansam
  13465, -- Mountain Silversage
  13466, -- Sorrowmoss
  13467, -- Icecap
  13468, -- Black Lotus
}

-- Inscription
database["Inscription"] = {
  19227, -- Ace of Beasts
  19230, -- Two of Beasts
  19231, -- Three of Beasts
  19232, -- Four of Beasts
  19233, -- Five of Beasts
  19234, -- Six of Beasts
  19235, -- Seven of Beasts
  19236, -- Eight of Beasts
  19258, -- Ace of Warlords
  19259, -- Two of Warlords
  19260, -- Three of Warlords
  19261, -- Four of Warlords
  19262, -- Five of Warlords
  19263, -- Six of Warlords
  19264, -- Seven of Warlords
  19265, -- Eight of Warlords
  19268, -- Ace of Elementals
  19269, -- Two of Elementals
  19270, -- Three of Elementals
  19271, -- Four of Elementals
  19272, -- Five of Elementals
  19273, -- Six of Elementals
  19274, -- Seven of Elementals
  19275, -- Eight of Elementals
  19276, -- Ace of Portals
  19278, -- Two of Portals
  19279, -- Three of Portals
  19280, -- Four of Portals
  19281, -- Five of Portals
  19282, -- Six of Portals
  19283, -- Seven of Portals
  19284, -- Eight of Portals
}

-- Jewelcrafting
database["Jewelcrafting"] = {
  774, -- Malachite
  818, -- Tigerseye
  1206, -- Moss Agate
  1210, -- Shadowgem
  1529, -- Jade
  1705, -- Lesser Moonstone
  3864, -- Citrine
  5498, -- Small Lustrous Pearl
  5500, -- Iridescent Pearl
  7909, -- Aquamarine
  7910, -- Star Ruby
  7971, -- Black Pearl
  11382, -- Blood of the Mountain
  12361, -- Blue Sapphire
  12363, -- Arcane Crystal
  12364, -- Huge Emerald
  12799, -- Large Opal
  12800, -- Azerothian Diamond
  13926, -- Golden Pearl
  18335, -- Pristine Black Diamond
}

-- Leather
database["Leather"] = {
  783, -- Light Hide
  2318, -- Light Leather
  2319, -- Medium Leather
  2934, -- Ruined Leather Scraps
  4231, -- Cured Light Hide
  4232, -- Medium Hide
  4233, -- Cured Medium Hide
  4234, -- Heavy Leather
  4235, -- Heavy Hide
  4236, -- Cured Heavy Hide
  4289, -- Salt
  4304, -- Thick Leather
  4461, -- Raptor Hide
  5082, -- Thin Kodo Leather
  5116, -- Long Tail Feather
  5784, -- Slimy Murloc Scale
  5785, -- Thick Murloc Scale
  6470, -- Deviate Scale
  6471, -- Perfect Deviate Scale
  7286, -- Black Whelp Scale
  7392, -- Green Whelp Scale
  8150, -- Deeprock Salt
  8154, -- Scorpid Scale
  8165, -- Worn Dragonscale
  8167, -- Turtle Scale
  8168, -- Jet Black Feather
  8169, -- Thick Hide
  8170, -- Rugged Leather
  8171, -- Rugged Hide
  8172, -- Cured Thick Hide
  12810, -- Enchanted Leather
  15407, -- Cured Rugged Hide
  15408, -- Heavy Scorpid Scale
  15409, -- Refined Deeprock Salt
  15410, -- Scale of Onyxia
  15412, -- Green Dragonscale
  15414, -- Red Dragonscale
  15415, -- Blue Dragonscale
  15416, -- Black Dragonscale
  15417, -- Devilsaur Leather
  15419, -- Warbear Leather
  17012, -- Core Leather
}

-- Meat & Fish
database["MeatFish"] = {
  723, -- Goretusk Liver
  729, -- Stringy Vulture Meat
  730, -- Murloc Eye
  731, -- Goretusk Snout
  769, -- Chunk of Boar Meat
  1015, -- Lean Wolf Flank
  1080, -- Tough Condor Meat
  1468, -- Murloc Fin
  2251, -- Gooey Spider Leg
  2665, -- Stormwind Seasoning Herbs
  2672, -- Stringy Wolf Meat
  2673, -- Coyote Meat
  2674, -- Crawler Meat
  2675, -- Crawler Claw
  2677, -- Boar Ribs
  2886, -- Crag Boar Rib
  2924, -- Crocolisk Meat
  3172, -- Boar Intestines
  3173, -- Bear Meat
  3174, -- Spider Ichor
  3404, -- Buzzard Wing
  3667, -- Tender Crocolisk Meat
  3685, -- Raptor Egg
  3712, -- Turtle Meat
  3730, -- Big Bear Meat
  3731, -- Lion Meat
  4603, -- Raw Spotted Yellowtail
  4655, -- Giant Clam Meat
  5465, -- Small Spider Leg
  5466, -- Scorpid Stinger
  5467, -- Kodo Meat
  5468, -- Soft Frenzy Flesh
  5469, -- Strider Meat
  5470, -- Thunder Lizard Tail
  5471, -- Stag Meat
  5503, -- Clam Meat
  5504, -- Tangy Clam Meat
  6289, -- Raw Longjaw Mud Snapper
  6291, -- Raw Brilliant Smallfish
  6303, -- Raw Slitherskin Mackerel
  6308, -- Raw Bristle Whisker Catfish
  6317, -- Raw Loch Frenzy
  6361, -- Raw Rainbow Fin Albacore
  6362, -- Raw Rockscale Cod
  6889, -- Small Egg
  7974, -- Zesty Clam Meat
  8365, -- Raw Mithril Head Trout
  8959, -- Raw Spinefin Halibut
  12037, -- Mystery Meat
  12184, -- Raptor Flesh
  12202, -- Tiger Meat
  12203, -- Red Wolf Meat
  12204, -- Heavy Kodo Meat
  12205, -- White Spider Meat
  12206, -- Tender Crab Meat
  12207, -- Giant Egg
  12208, -- Tender Wolf Meat
  12223, -- Meaty Bat Wing
  13754, -- Raw Glossy Mightfish
  13756, -- Raw Summer Bass
  13758, -- Raw Redgill
  13759, -- Raw Nightfin Snapper
  13760, -- Raw Sunscale Salmon
  13888, -- Darkclaw Lobster
  13889, -- Raw Whitescale Salmon
  20424, -- Sandworm Meat
  21024, -- Chimaerok Tenderloin
  21071, -- Raw Sagefish
  21153, -- Raw Greater Sagefish
}

-- Metal & Stone
database["MetalStone"] = {
  2770, -- Copper Ore
  2771, -- Tin Ore
  2772, -- Iron Ore
  2775, -- Silver Ore
  2776, -- Gold Ore
  2835, -- Rough Stone
  2836, -- Coarse Stone
  2838, -- Heavy Stone
  2840, -- Copper Bar
  2841, -- Bronze Bar
  2842, -- Silver Bar
  3470, -- Rough Grinding Stone
  3478, -- Coarse Grinding Stone
  3486, -- Heavy Grinding Stone
  3575, -- Iron Bar
  3576, -- Tin Bar
  3577, -- Gold Bar
  3857, -- Coal
  3858, -- Mithril Ore
  3859, -- Steel Bar
  3860, -- Mithril Bar
  6037, -- Truesilver Bar
  7911, -- Truesilver Ore
  7912, -- Solid Stone
  7966, -- Solid Grinding Stone
  10620, -- Thorium Ore
  11370, -- Dark Iron Ore
  11371, -- Dark Iron Bar
  12359, -- Thorium Bar
  12360, -- Arcanite Bar
  12365, -- Dense Stone
  12644, -- Dense Grinding Stone
  12655, -- Enchanted Thorium Bar
  12809, -- Guardian Stone
  17203, -- Sulfuron Ingot
  17771, -- Enchanted Elementium Bar
  18562, -- Elementium Ingot
  18567, -- Elemental Flux
  22202, -- Small Obsidian Shard
  22203, -- Large Obsidian Shard
}

-- Other Tradegoods
database["OtherTradegoods"] = {
  1288, -- Large Venom Sac
  1475, -- Small Venom Sac
  2324, -- Bleach
  2325, -- Black Dye
  2604, -- Red Dye
  2605, -- Green Dye
  2678, -- Mild Spices
  2880, -- Weak Flux
  3164, -- Discolored Worg Heart
  3371, -- Crystal Vial
  3372, -- Cracked Vial
  3466, -- Strong Flux
  4340, -- Gray Dye
  4341, -- Yellow Dye
  4342, -- Purple Dye
  4402, -- Small Flame Sac
  4470, -- Simple Wood
  5523, -- Small Barnacled Clam
  5524, -- Thick-Shelled Clam
  5635, -- Sharp Claw
  5637, -- Large Fang
  6260, -- Blue Dye
  6261, -- Orange Dye
  6358, -- Oily Blackmouth
  6359, -- Firefin Snapper
  6370, -- Blackmouth Oil
  6371, -- Fire Oil
  7072, -- Naga Scale
  7973, -- Big-Mouth Clam
  8925, -- Tainted Vial
  9210, -- Ghost Dye
  9262, -- Black Vitriol
  9719, -- Broken Blade of Heroes
  10290, -- Pink Dye
  11291, -- Star Wood
  12662, -- Demonic Rune
  12804, -- Powerful Mojo
  12811, -- Righteous Orb
  13422, -- Stonescale Eel
  13423, -- Stonescale Oil
  13757, -- Lightning Eel
  17010, -- Fiery Core
  17011, -- Lava Core
  17204, -- Eye of Sulfuras
  18240, -- Ogre Tannin
  18256, -- Melted Vial
  19441, -- Huge Venom Sac
  19943, -- Massive Mojo
  20520, -- Dark Rune
}

-- Parts
database["Parts"] = {
  814, -- Flask of Oil
  4357, -- Rough Blasting Powder
  4359, -- Handful of Copper Bolts
  4364, -- Coarse Blasting Powder
  4371, -- Bronze Tube
  4375, -- Whirring Bronze Gizmo
  4377, -- Heavy Blasting Powder
  4382, -- Bronze Framework
  4387, -- Iron Strut
  4389, -- Gyrochronatom
  4399, -- Wooden Stock
  4400, -- Heavy Stock
  4404, -- Silver Contact
  4611, -- Blue Pearl
  7071, -- Iron Buckle
  7191, -- Fused Wiring
  9060, -- Inlaid Mithril Cylinder
  9061, -- Goblin Rocket Fuel
  10505, -- Solid Blasting Powder
  10558, -- Gold Power Core
  10559, -- Mithril Tube
  10560, -- Unstable Trigger
  10561, -- Mithril Casing
  10647, -- Engineer's Ink
  15992, -- Dense Blasting Powder
  15994, -- Thorium Widget
  16000, -- Thorium Tube
  16006, -- Delicate Arcanite Converter
  17056, -- Light Feather
  18631, -- Truesilver Transformer
}

local function converttohex(rgb)
  return string.format("%02x%02x%02x", rgb.r * 255, rgb.g * 255, rgb.b * 255)
end

local function converttorgb(hex, as_table)
  if as_table then
    return {
      r = tonumber("0x" .. strsub(hex, 1, 2)) / 255,
      g = tonumber("0x" .. strsub(hex, 3, 4)) / 255,
      b = tonumber("0x" .. strsub(hex, 5, 6)) / 255,
    }
  else
    -- as 3 values
    return tonumber("0x" .. hex:sub(1, 2)) / 255,
      tonumber("0x" .. hex:sub(3, 4)) / 255,
      tonumber("0x" .. hex:sub(5, 6)) / 255
  end
end


local function formatBagTitle(self, title, hex)
  local prefix = ""
  if self.db.profile.prefixCategories then
    if self.db.profile.prefixCategories == "!CUSTOM" then
      prefix = self.db.profile.customPrefix
    else
      prefix = self.db.profile.prefixCategories
    end
  end
  if self.db.profile.coloredPrefix then
    prefix = "|cff" .. converttohex(self.db.profile.color.prefix) .. prefix .. "|r"
    if self.db.profile.coloredCategories then
      return prefix .. "|cff" .. hex .. title .. "|r"
    else
      return prefix .. title
    end
  else
    if self.db.profile.coloredCategories then
      return prefix .. "|cff" .. hex .. title .. "|r"
    else
      return prefix .. title
    end
  end
end

local function MatchIDs_Init(self)
  wipe(Result)

  if self.db.profile.moveMergedConsumables then
    Result[formatBagTitle(self, L["Consumables"], converttohex(self.db.profile.color.mergedConsumables))] =
      AddToSet(database["Bandages"], database["Consumables"], database["FoodsandDrinks"], database["OtherConsumables"])
  else
    if self.db.profile.moveBandages then
      Result[formatBagTitle(self, L["Bandages"], converttohex(self.db.profile.color.Bandages))] =
        AddToSet(database["Bandages"])
    end
    if self.db.profile.moveConsumables then
      Result[formatBagTitle(self, L["Consumables"], converttohex(self.db.profile.color.Consumables))] =
        AddToSet(database["Consumables"])
    end
    if self.db.profile.moveFoodsandDrinks then
      Result[formatBagTitle(self, L["Foods and Drinks"], converttohex(self.db.profile.color.FoodsandDrinks))] =
        AddToSet(database["FoodsandDrinks"])
    end
    if self.db.profile.moveOtherConsumables then
      Result[formatBagTitle(self, L["Other Consumables"], converttohex(self.db.profile.color.OtherConsumables))] =
        AddToSet(database["OtherConsumables"])
    end
  end
  if self.db.profile.moveMergedFlasksElixirsPotions then
    Result[formatBagTitle(
      self,
      L["Flasks, Elixirs & Potions"],
      converttohex(self.db.profile.color.mergedFlasksElixirsPotions)
    )] =
      AddToSet(database["Elixirs"], database["Flasks"], database["Potions"])
  else
    if self.db.profile.moveElixirs then
      Result[formatBagTitle(self, L["Elixirs"], converttohex(self.db.profile.color.Elixirs))] =
        AddToSet(database["Elixirs"])
    end
    if self.db.profile.moveFlasks then
      Result[formatBagTitle(self, L["Flasks"], converttohex(self.db.profile.color.Flasks))] =
        AddToSet(database["Flasks"])
    end
    if self.db.profile.movePotions then
      Result[formatBagTitle(self, L["Potions"], converttohex(self.db.profile.color.Potions))] =
        AddToSet(database["Potions"])
    end
  end
  if self.db.profile.moveHealthstone then
    Result[formatBagTitle(self, L["Healthstone"], converttohex(self.db.profile.color.Healthstone))] =
      AddToSet(database["Healthstone"])
  end
  if self.db.profile.moveMergedTemporaryPermanentEnhancements then
    Result[formatBagTitle(
      self,
      L["Temporary & Permanent Enhancements"],
      converttohex(self.db.profile.color.mergedTemporaryPermanentEnhancements)
    )] =
      AddToSet(database["PermanentEnhancements"], database["TemporaryEnhancements"])
  else
    if self.db.profile.movePermanentEnhancements then
      Result[formatBagTitle(
        self,
        L["Permanent Enhancements"],
        converttohex(self.db.profile.color.PermanentEnhancements)
      )] =
        AddToSet(database["PermanentEnhancements"])
    end
    if self.db.profile.moveTemporaryEnhancements then
      Result[formatBagTitle(
        self,
        L["Temporary Enhancements"],
        converttohex(self.db.profile.color.TemporaryEnhancements)
      )] =
        AddToSet(database["TemporaryEnhancements"])
    end
  end
  if self.db.profile.moveMergedTradegoods then
    Result[formatBagTitle(self, L["Tradegoods"], converttohex(self.db.profile.color.mergedTradegoods))] = AddToSet(
      database["Cloth"],
      database["Elemental"],
      database["Enchanting"],
      database["Herbs"],
      database["Inscription"],
      database["Jewelcrafting"],
      database["Leather"],
      database["MeatFish"],
      database["MetalStone"],
      database["OtherTradegoods"],
      database["Parts"]
    )
  else
    if self.db.profile.moveCloth then
      Result[formatBagTitle(self, L["Cloth"], converttohex(self.db.profile.color.Cloth))] = AddToSet(database["Cloth"])
    end
    if self.db.profile.moveElemental then
      Result[formatBagTitle(self, L["Elemental"], converttohex(self.db.profile.color.Elemental))] =
        AddToSet(database["Elemental"])
    end
    if self.db.profile.moveEnchanting then
      Result[formatBagTitle(self, L["Enchanting"], converttohex(self.db.profile.color.Enchanting))] =
        AddToSet(database["Enchanting"])
    end
    if self.db.profile.moveHerbs then
      Result[formatBagTitle(self, L["Herbs"], converttohex(self.db.profile.color.Herbs))] = AddToSet(database["Herbs"])
    end
    if self.db.profile.moveInscription then
      Result[formatBagTitle(self, L["Inscription"], converttohex(self.db.profile.color.Inscription))] =
        AddToSet(database["Inscription"])
    end
    if self.db.profile.moveJewelcrafting then
      Result[formatBagTitle(self, L["Jewelcrafting"], converttohex(self.db.profile.color.Jewelcrafting))] =
        AddToSet(database["Jewelcrafting"])
    end
    if self.db.profile.moveLeather then
      Result[formatBagTitle(self, L["Leather"], converttohex(self.db.profile.color.Leather))] =
        AddToSet(database["Leather"])
    end
    if self.db.profile.moveMeatFish then
      Result[formatBagTitle(self, L["Meat & Fish"], converttohex(self.db.profile.color.MeatFish))] =
        AddToSet(database["MeatFish"])
    end
    if self.db.profile.moveMetalStone then
      Result[formatBagTitle(self, L["Metal & Stone"], converttohex(self.db.profile.color.MetalStone))] =
        AddToSet(database["MetalStone"])
    end
    if self.db.profile.moveOtherTradegoods then
      Result[formatBagTitle(self, L["Other Tradegoods"], converttohex(self.db.profile.color.OtherTradegoods))] =
        AddToSet(database["OtherTradegoods"])
    end
    if self.db.profile.moveParts then
      Result[formatBagTitle(self, L["Parts"], converttohex(self.db.profile.color.Parts))] = AddToSet(database["Parts"])
    end
  end

  return Result
end

local setFilter = AdiBags:RegisterFilter("Classic", 98, "ABEvent-1.0")
setFilter.uiName = string.format("|cffd6ff5a%s|r", L["Classic"])
setFilter.uiDesc =
  string.format("%s\n|cffffd800%s: 1.0.4|r", L["Items from the main game."], L["Filter version"])

function setFilter:OnInitialize()
  self.db = AdiBags.db:RegisterNamespace("Classic", {
    profile = {
      coloredCategories = true,
      prefixCategories = "",
      customPrefix = "",
      coloredPrefix = true,
      moveMergedConsumables = false,
      moveBandages = true,
      moveConsumables = true,
      moveFoodsandDrinks = true,
      moveOtherConsumables = true,
      moveMergedFlasksElixirsPotions = true,
      moveElixirs = true,
      moveFlasks = true,
      movePotions = true,
      moveHealthstone = false,
      moveMergedTemporaryPermanentEnhancements = true,
      movePermanentEnhancements = true,
      moveTemporaryEnhancements = true,
      moveMergedTradegoods = true,
      moveCloth = true,
      moveElemental = true,
      moveEnchanting = true,
      moveHerbs = true,
      moveInscription = true,
      moveJewelcrafting = true,
      moveLeather = true,
      moveMeatFish = true,
      moveMetalStone = true,
      moveOtherTradegoods = true,
      moveParts = true,

      color = {
        prefix = converttorgb("d6ff5a", true),
        mergedConsumables = converttorgb("7aa36f", true),
        Bandages = converttorgb("fff600", true),
        Consumables = converttorgb("49678d", true),
        FoodsandDrinks = converttorgb("9b59b6", true),
        OtherConsumables = converttorgb("4e878c", true),
        mergedFlasksElixirsPotions = converttorgb("769fb6", true),
        Elixirs = converttorgb("689a8c", true),
        Flasks = converttorgb("b60f96", true),
        Potions = converttorgb("9dbbae", true),
        Healthstone = converttorgb("93e5ab", true),
        mergedTemporaryPermanentEnhancements = converttorgb("5a7684", true),
        PermanentEnhancements = converttorgb("92afd7", true),
        TemporaryEnhancements = converttorgb("c5d1eb", true),
        mergedTradegoods = converttorgb("786f52", true),
        Cloth = converttorgb("feb95f", true),
        Elemental = converttorgb("c2095a", true),
        Enchanting = converttorgb("540d6e", true),
        Herbs = converttorgb("0ead69", true),
        Inscription = converttorgb("ffd23f", true),
        Jewelcrafting = converttorgb("090446", true),
        Leather = converttorgb("563635", true),
        MeatFish = converttorgb("f71735", true),
        MetalStone = converttorgb("6e9075", true),
        OtherTradegoods = converttorgb("81f0e5", true),
        Parts = converttorgb("5b6057", true),
      },
    },
  })
end

function setFilter:Update()
  MatchIDs = nil
  self:SendMessage("AdiBags_FiltersChanged")
end

function setFilter:OnEnable()
  AdiBags:UpdateFilters()
end

function setFilter:OnDisable()
  AdiBags:UpdateFilters()
end

function setFilter:Filter(slotData)
  MatchIDs = MatchIDs or MatchIDs_Init(self)
  for i, name in pairs(MatchIDs) do
    -- Override Method
    if MatchIDs[i]["override"] then
      slotData["loc"] = ItemLocation:CreateFromBagAndSlot(slotData.bag, slotData.slot)
      if slotData["loc"] and slotData["loc"]:IsValid() then
        if MatchIDs[i]["override"](slotData.loc) then
          return i
        end
      end

      -- Bonus Condition (triggers when bonus condition is not fulfilled)
    elseif MatchIDs[i]["bonus_condition"] then
      if name[slotData.itemId] then
        slotData["loc"] = ItemLocation:CreateFromBagAndSlot(slotData.bag, slotData.slot)
        if slotData["loc"] and slotData["loc"]:IsValid() then
          if not MatchIDs[i]["bonus_condition"](slotData.loc) then
            -- THERE IS A NOT HERE!
            return i
          end
        end
      end

      -- Standard ID Matching
    elseif name[slotData.itemId] then
      return i
    end
  end
end

function setFilter:GetOptions()
  return {
    general_config = {
      type = "group",
      name = L["General Settings"],
      desc = L["Settings affecting all categories."],
      inline = true,
      order = 1,
      args = {
        description = {
          type = "description",
          name = string.format(
            "%s |cffffd800%s |cff529F00%s|r",
            L["These settings affect all categories of this filter."],
            L["If you overwrite prefix or categorie color, you either need to toggle the color setting twice or reload."],
            L["AdiBags never intended to use icons, so they are glitchy. Make sure to disable prefix color, if you use an icon."]
          ),
          order = 1,
        },
        coloredCategories = {
          name = string.format("|cffFDFD96%s|r", L["Colored Categories"]),
          desc = L["Should Categories be colored?"],
          width = "full",
          type = "toggle",
          order = 10,
        },
        prefixCategories = {
          name = L["Prefix Categories"],
          desc = L["Select a prefix for the categories, if you like."],
          type = "select",
          order = 20,
          values = {
            [""] = L["None"],
            ["!CUSTOM"] = L["Custom Prefix"],
            ["C"] = "C",
            ["C-"] = "C-",
            ["0."] = "0.",
            ["V"] = "V",
            ["V-"] = "V-",
            ["|T4279397:" .. AdiBags.HEADER_SIZE .. ":" .. AdiBags.HEADER_SIZE .. ":-2:-10|t"] = "|T4279397:"
              .. AdiBags.HEADER_SIZE
              .. "|t",
            ["|T1120721:" .. AdiBags.HEADER_SIZE .. ":" .. AdiBags.HEADER_SIZE .. ":-2:-10|t"] = "|T1120721:"
              .. AdiBags.HEADER_SIZE
              .. "|t",
            ["|T626006:" .. AdiBags.HEADER_SIZE .. ":" .. AdiBags.HEADER_SIZE .. ":-2:-10|t"] = "|T626006:"
              .. AdiBags.HEADER_SIZE
              .. "|t",
            ["|T626003:" .. AdiBags.HEADER_SIZE .. ":" .. AdiBags.HEADER_SIZE .. ":-2:-10|t"] = "|T626003:"
              .. AdiBags.HEADER_SIZE
              .. "|t",
            ["|T626008:" .. AdiBags.HEADER_SIZE .. ":" .. AdiBags.HEADER_SIZE .. ":-2:-10|t"] = "|T626008:"
              .. AdiBags.HEADER_SIZE
              .. "|t",
          },
        },
        customPrefix = {
          name = L["Custom Prefix"],
          desc = L["Enter a custom prefix for the categories."],
          type = "input",
          order = 30,
          width = "full",
          disabled = function()
            return self.db.profile.prefixCategories ~= "!CUSTOM"
          end,
        },
        coloredPrefix = {
          name = string.format("|cffB9FFB9%s|r", L["Colored Prefix"]),
          desc = L["Should the prefix be colored to the filter color? (Only works for text-prefixes, for obvious reasons.)"],
          type = "toggle",
          order = 40,
        },
        prefixColor = {
          name = L["Prefix Color"],
          desc = L["Select a color for the prefix."],
          type = "color",
          order = 50,
          hasAlpha = false,
          disabled = function()
            return not self.db.profile.coloredPrefix
          end,
          get = function()
            local color = self.db.profile.color.prefix
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.prefix
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
      },
    },
    Consumables_config = {
      type = "group",
      name = L["Consumables"],
      desc = "", -- doesnt work,
      inline = true,
      order = 52,
      args = {
        Legendaries_desc = {
          type = "description",
          name = L["Items you can eat or use to improve yourself"],
          order = 53,
        },
        moveMergedConsumables = {
          name = string.format(L["%sMerge %s%s"], "|cffffd800", L["Consumables"], "|r"),
          desc = string.format(L["Merge all %s into a single category."], L["Consumables"]),
          type = "toggle",
          width = 1.5,
          order = 54,
        },
        colorMergedConsumables = {
          name = L["Color"],
          desc = string.format(L["Select a color for the merged %s category."], L["Consumables"]),
          type = "color",
          order = 55,
          hasAlpha = false,
          disabled = function()
            return not self.db.profile.moveMergedConsumables
          end,
          get = function()
            local color = self.db.profile.color.mergedConsumables
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.mergedConsumables
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_1 = {
          type = "header",
          name = "",
          order = 56,
        },
        moveBandages = {
          name = L["Bandages"],
          desc = L["Bandages to heal yourself."],
          type = "toggle",
          width = 1.5,
          order = 57,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
        },
        colorBandages = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Bandages"]),
          type = "color",
          order = 58,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
          get = function()
            local color = self.db.profile.color.Bandages
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Bandages
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_2 = {
          type = "header",
          name = "",
          order = 59,
        },
        moveConsumables = {
          name = L["Consumables"],
          desc = L["Consumables to consume."],
          type = "toggle",
          width = 1.5,
          order = 60,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
        },
        colorConsumables = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Consumables"]),
          type = "color",
          order = 61,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
          get = function()
            local color = self.db.profile.color.Consumables
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Consumables
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_3 = {
          type = "header",
          name = "",
          order = 62,
        },
        moveFoodsandDrinks = {
          name = L["Foods and Drinks"],
          desc = L["Foods and Drinks to consume."],
          type = "toggle",
          width = 1.5,
          order = 63,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
        },
        colorFoodsandDrinks = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Foods and Drinks"]),
          type = "color",
          order = 64,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
          get = function()
            local color = self.db.profile.color.FoodsandDrinks
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.FoodsandDrinks
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_4 = {
          type = "header",
          name = "",
          order = 65,
        },
        moveOtherConsumables = {
          name = L["Other Consumables"],
          desc = L["Other Consumables to consume."],
          type = "toggle",
          width = 1.5,
          order = 66,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
        },
        colorOtherConsumables = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Other Consumables"]),
          type = "color",
          order = 67,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
          get = function()
            local color = self.db.profile.color.OtherConsumables
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.OtherConsumables
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
      },
    },
    FlasksElixirsPotions_config = {
      type = "group",
      name = L["Flasks, Elixirs & Potions"],
      desc = "", -- doesnt work,
      inline = true,
      order = 68,
      args = {
        Legendaries_desc = {
          type = "description",
          name = L["Drink this for a powerup!"],
          order = 69,
        },
        moveMergedFlasksElixirsPotions = {
          name = string.format(L["%sMerge %s%s"], "|cffffd800", L["Flasks, Elixirs & Potions"], "|r"),
          desc = string.format(L["Merge all %s into a single category."], L["Flasks, Elixirs & Potions"]),
          type = "toggle",
          width = 1.5,
          order = 70,
        },
        colorMergedFlasksElixirsPotions = {
          name = L["Color"],
          desc = string.format(L["Select a color for the merged %s category."], L["Flasks, Elixirs & Potions"]),
          type = "color",
          order = 71,
          hasAlpha = false,
          disabled = function()
            return not self.db.profile.moveMergedFlasksElixirsPotions
          end,
          get = function()
            local color = self.db.profile.color.mergedFlasksElixirsPotions
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.mergedFlasksElixirsPotions
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_5 = {
          type = "header",
          name = "",
          order = 72,
        },
        moveElixirs = {
          name = L["Elixirs"],
          desc = L["Elixirs to drink."],
          type = "toggle",
          width = 1.5,
          order = 73,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
        },
        colorElixirs = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Elixirs"]),
          type = "color",
          order = 74,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
          get = function()
            local color = self.db.profile.color.Elixirs
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Elixirs
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_6 = {
          type = "header",
          name = "",
          order = 75,
        },
        moveFlasks = {
          name = L["Flasks"],
          desc = L["Flasks to drink."],
          type = "toggle",
          width = 1.5,
          order = 76,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
        },
        colorFlasks = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Flasks"]),
          type = "color",
          order = 77,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
          get = function()
            local color = self.db.profile.color.Flasks
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Flasks
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_7 = {
          type = "header",
          name = "",
          order = 78,
        },
        movePotions = {
          name = L["Potions"],
          desc = L["Potions to drink."],
          type = "toggle",
          width = 1.5,
          order = 79,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
        },
        colorPotions = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Potions"]),
          type = "color",
          order = 80,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
          get = function()
            local color = self.db.profile.color.Potions
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Potions
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
      },
    },
    Healthstone_config = {
      type = "group",
      name = L["Healthstone"],
      desc = "", -- doesnt work,
      inline = true,
      order = 81,
      args = {
        Legendaries_desc = {
          type = "description",
          name = L["Just a healthstone."],
          order = 82,
        },
        moveHealthstone = {
          name = L["Healthstone"],
          desc = L["Just your typical healthstone."],
          type = "toggle",
          width = 1.5,
          order = 83,
        },
        colorHealthstone = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Healthstone"]),
          type = "color",
          order = 84,
          disabled = function()
            return self.db.profile.moveMergedHealthstone
          end,
          get = function()
            local color = self.db.profile.color.Healthstone
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Healthstone
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
      },
    },
    TemporaryPermanentEnhancements_config = {
      type = "group",
      name = L["Temporary & Permanent Enhancements"],
      desc = "", -- doesnt work,
      inline = true,
      order = 85,
      args = {
        Legendaries_desc = {
          type = "description",
          name = L["Use these for a powerup!"],
          order = 86,
        },
        moveMergedTemporaryPermanentEnhancements = {
          name = string.format(L["%sMerge %s%s"], "|cffffd800", L["Temporary & Permanent Enhancements"], "|r"),
          desc = string.format(L["Merge all %s into a single category."], L["Temporary & Permanent Enhancements"]),
          type = "toggle",
          width = 1.5,
          order = 87,
        },
        colorMergedTemporaryPermanentEnhancements = {
          name = L["Color"],
          desc = string.format(
            L["Select a color for the merged %s category."],
            L["Temporary & Permanent Enhancements"]
          ),
          type = "color",
          order = 88,
          hasAlpha = false,
          disabled = function()
            return not self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
          get = function()
            local color = self.db.profile.color.mergedTemporaryPermanentEnhancements
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.mergedTemporaryPermanentEnhancements
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_8 = {
          type = "header",
          name = "",
          order = 89,
        },
        movePermanentEnhancements = {
          name = L["Permanent Enhancements"],
          desc = L["These are permanent enhancements that you can typically apply to armor to improve it."],
          type = "toggle",
          width = 1.5,
          order = 90,
          disabled = function()
            return self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
        },
        colorPermanentEnhancements = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Permanent Enhancements"]),
          type = "color",
          order = 91,
          disabled = function()
            return self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
          get = function()
            local color = self.db.profile.color.PermanentEnhancements
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.PermanentEnhancements
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_9 = {
          type = "header",
          name = "",
          order = 92,
        },
        moveTemporaryEnhancements = {
          name = L["Temporary Enhancements"],
          desc = L["These are temporary enhancements that you can typically apply to armor to improve it."],
          type = "toggle",
          width = 1.5,
          order = 93,
          disabled = function()
            return self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
        },
        colorTemporaryEnhancements = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Temporary Enhancements"]),
          type = "color",
          order = 94,
          disabled = function()
            return self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
          get = function()
            local color = self.db.profile.color.TemporaryEnhancements
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.TemporaryEnhancements
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
      },
    },
    Tradegoods_config = {
      type = "group",
      name = L["Tradegoods"],
      desc = "", -- doesnt work,
      inline = true,
      order = 95,
      args = {
        Legendaries_desc = {
          type = "description",
          name = L["Trading tradegoods is good. Trade tradegoods for good goods."],
          order = 96,
        },
        moveMergedTradegoods = {
          name = string.format(L["%sMerge %s%s"], "|cffffd800", L["Tradegoods"], "|r"),
          desc = string.format(L["Merge all %s into a single category."], L["Tradegoods"]),
          type = "toggle",
          width = 1.5,
          order = 97,
        },
        colorMergedTradegoods = {
          name = L["Color"],
          desc = string.format(L["Select a color for the merged %s category."], L["Tradegoods"]),
          type = "color",
          order = 98,
          hasAlpha = false,
          disabled = function()
            return not self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.mergedTradegoods
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.mergedTradegoods
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_10 = {
          type = "header",
          name = "",
          order = 99,
        },
        moveCloth = {
          name = L["Cloth"],
          desc = L["Cloth used in Tailoring."],
          type = "toggle",
          width = 1.5,
          order = 100,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorCloth = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Cloth"]),
          type = "color",
          order = 101,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Cloth
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Cloth
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_11 = {
          type = "header",
          name = "",
          order = 102,
        },
        moveElemental = {
          name = L["Elemental"],
          desc = L["Elementals used in all professions."],
          type = "toggle",
          width = 1.5,
          order = 103,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorElemental = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Elemental"]),
          type = "color",
          order = 104,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Elemental
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Elemental
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_12 = {
          type = "header",
          name = "",
          order = 105,
        },
        moveEnchanting = {
          name = L["Enchanting"],
          desc = L["Enchanting materials for enchanting weapons & armor."],
          type = "toggle",
          width = 1.5,
          order = 106,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorEnchanting = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Enchanting"]),
          type = "color",
          order = 107,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Enchanting
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Enchanting
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_13 = {
          type = "header",
          name = "",
          order = 108,
        },
        moveHerbs = {
          name = L["Herbs"],
          desc = L["Herbs used in Alchemy & Inscription."],
          type = "toggle",
          width = 1.5,
          order = 109,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorHerbs = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Herbs"]),
          type = "color",
          order = 110,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Herbs
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Herbs
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_14 = {
          type = "header",
          name = "",
          order = 111,
        },
        moveInscription = {
          name = L["Inscription"],
          desc = L["Inscription materials for creating glyphs or other paper related goods."],
          type = "toggle",
          width = 1.5,
          order = 112,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorInscription = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Inscription"]),
          type = "color",
          order = 113,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Inscription
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Inscription
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_15 = {
          type = "header",
          name = "",
          order = 114,
        },
        moveJewelcrafting = {
          name = L["Jewelcrafting"],
          desc = L["Jewelcrafting materials for creating rings, necklaces, gems, etc."],
          type = "toggle",
          width = 1.5,
          order = 115,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorJewelcrafting = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Jewelcrafting"]),
          type = "color",
          order = 116,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Jewelcrafting
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Jewelcrafting
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_16 = {
          type = "header",
          name = "",
          order = 117,
        },
        moveLeather = {
          name = L["Leather"],
          desc = L["Leather used in Leatherworking."],
          type = "toggle",
          width = 1.5,
          order = 118,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorLeather = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Leather"]),
          type = "color",
          order = 119,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Leather
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Leather
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_17 = {
          type = "header",
          name = "",
          order = 120,
        },
        moveMeatFish = {
          name = L["Meat & Fish"],
          desc = L["Meat & Fish used in Cooking."],
          type = "toggle",
          width = 1.5,
          order = 121,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorMeatFish = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Meat & Fish"]),
          type = "color",
          order = 122,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.MeatFish
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.MeatFish
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_18 = {
          type = "header",
          name = "",
          order = 123,
        },
        moveMetalStone = {
          name = L["Metal & Stone"],
          desc = L["Metal & Stone used in Blacksmithing."],
          type = "toggle",
          width = 1.5,
          order = 124,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorMetalStone = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Metal & Stone"]),
          type = "color",
          order = 125,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.MetalStone
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.MetalStone
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_19 = {
          type = "header",
          name = "",
          order = 126,
        },
        moveOtherTradegoods = {
          name = L["Other Tradegoods"],
          desc = L["Other items used in various professions."],
          type = "toggle",
          width = 1.5,
          order = 127,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorOtherTradegoods = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Other Tradegoods"]),
          type = "color",
          order = 128,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.OtherTradegoods
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.OtherTradegoods
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_20 = {
          type = "header",
          name = "",
          order = 129,
        },
        moveParts = {
          name = L["Parts"],
          desc = L["Parts used in Engineering."],
          type = "toggle",
          width = 1.5,
          order = 130,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorParts = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Parts"]),
          type = "color",
          order = 131,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Parts
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Parts
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
      },
    },
  },
    AdiBags:GetOptionHandler(self, false, function()
      return self:Update()
    end)
end
